/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 11 "parse_tab.y"

#if HAVE_CONFIG_H
#include "config.h"
#endif
#define YYSTYPE char *  /*  The generic type returned by all parse matches */
#undef YYDEBUG          /* no debug code please */
#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>       /* for HUGE_VAL and trunc */
#include <assert.h>
#include <stdio.h>
#include <ctype.h>
#include <unistd.h>
#include <limits.h>
#include <string.h>
#include <sys/time.h>

#include "list.h"
#include "cbuf.h"
#include "hostlist.h"
#include "xmalloc.h"
#include "xpoll.h"
#include "xregex.h"
#include "pluglist.h"
#include "arglist.h"
#include "device_private.h"
#include "device_serial.h"
#include "device_pipe.h"
#include "device_tcp.h"
#include "parse_util.h"
#include "error.h"

/*
 * A PreScript is a list of PreStmts.
 */
typedef struct {
    StmtType type;              /* delay/expect/send */
    char *str;                  /* expect string, send fmt, setplugstate plug */
    struct timeval tv;          /* delay value */
    int mp1;                    /* setplugstate/result plug match position */
    int mp2;                    /* setplugstate/result state/result match position */
    List prestmts;              /* subblock */
    List state_interps;         /* interpretations for setplugstate */
    List result_interps;        /* interpretations for setresult */
} PreStmt;
typedef List PreScript;

/*
 * Unprocessed Protocol (used during parsing).
 * This data will be copied for each instantiation of a device.
 */
typedef struct {
    char *name;                 /* specification name, e.g. "icebox" */
    struct timeval timeout;     /* timeout for this device */
    struct timeval ping_period; /* ping period for this device 0.0 = none */
    List plugs;                 /* list of plug names (e.g. "1" thru "10") */
    PreScript prescripts[NUM_SCRIPTS];  /* array of PreScripts */
} Spec;                                 /*   script may be NULL if undefined */

/* powerman.conf */
static void makeNode(char *nodestr, char *devstr, char *plugstr);
static void makeAlias(char *namestr, char *hostsstr);
static Stmt *makeStmt(PreStmt *p);
static void destroyStmt(Stmt *stmt);
static void makeDevice(char *devstr, char *specstr, char *hoststr,
                        char *portstr);

/* device config */
static PreStmt *makePreStmt(StmtType type, char *str, char *tvstr,
                      char *mp1str, char *mp2str, List prestmts,
                      List plugstate_interps, List result_interps);
static void destroyPreStmt(PreStmt *p);
static Spec *makeSpec(char *name);
static Spec *findSpec(char *name);
static int matchSpec(Spec * spec, void *key);
static void destroySpec(Spec * spec);
static void makeScript(int com, List stmts);
static void destroyStateInterp(StateInterp *i);
static StateInterp *makeStateInterp(InterpState state, char *str);
static List copyStateInterpList(List ilist);
static void destroyResultInterp(ResultInterp *i);
static ResultInterp *makeResultInterp(InterpResult result, char *str);
static List copyResultInterpList(List ilist);

/* utility functions */
static void _errormsg(char *msg);
static void _warnmsg(char *msg);
static long _strtolong(char *str);
static double _strtodouble(char *str);
static void _doubletotv(struct timeval *tv, double val);

extern int yylex();
void yyerror();


static List device_specs = NULL;      /* list of Spec's */
static Spec current_spec;             /* Holds a Spec as it is built */

#line 172 "parse_tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_PARSE_TAB_H_INCLUDED
# define YY_YY_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    TOK_LOGIN = 258,               /* TOK_LOGIN  */
    TOK_LOGOUT = 259,              /* TOK_LOGOUT  */
    TOK_STATUS = 260,              /* TOK_STATUS  */
    TOK_STATUS_ALL = 261,          /* TOK_STATUS_ALL  */
    TOK_STATUS_TEMP = 262,         /* TOK_STATUS_TEMP  */
    TOK_STATUS_TEMP_ALL = 263,     /* TOK_STATUS_TEMP_ALL  */
    TOK_STATUS_BEACON = 264,       /* TOK_STATUS_BEACON  */
    TOK_STATUS_BEACON_ALL = 265,   /* TOK_STATUS_BEACON_ALL  */
    TOK_BEACON_ON = 266,           /* TOK_BEACON_ON  */
    TOK_BEACON_ON_RANGED = 267,    /* TOK_BEACON_ON_RANGED  */
    TOK_BEACON_OFF = 268,          /* TOK_BEACON_OFF  */
    TOK_BEACON_OFF_RANGED = 269,   /* TOK_BEACON_OFF_RANGED  */
    TOK_ON = 270,                  /* TOK_ON  */
    TOK_ON_RANGED = 271,           /* TOK_ON_RANGED  */
    TOK_ON_ALL = 272,              /* TOK_ON_ALL  */
    TOK_OFF = 273,                 /* TOK_OFF  */
    TOK_OFF_RANGED = 274,          /* TOK_OFF_RANGED  */
    TOK_OFF_ALL = 275,             /* TOK_OFF_ALL  */
    TOK_CYCLE = 276,               /* TOK_CYCLE  */
    TOK_CYCLE_RANGED = 277,        /* TOK_CYCLE_RANGED  */
    TOK_CYCLE_ALL = 278,           /* TOK_CYCLE_ALL  */
    TOK_RESET = 279,               /* TOK_RESET  */
    TOK_RESET_RANGED = 280,        /* TOK_RESET_RANGED  */
    TOK_RESET_ALL = 281,           /* TOK_RESET_ALL  */
    TOK_PING = 282,                /* TOK_PING  */
    TOK_SPEC = 283,                /* TOK_SPEC  */
    TOK_EXPECT = 284,              /* TOK_EXPECT  */
    TOK_SETPLUGSTATE = 285,        /* TOK_SETPLUGSTATE  */
    TOK_SETRESULT = 286,           /* TOK_SETRESULT  */
    TOK_SEND = 287,                /* TOK_SEND  */
    TOK_DELAY = 288,               /* TOK_DELAY  */
    TOK_FOREACHPLUG = 289,         /* TOK_FOREACHPLUG  */
    TOK_FOREACHNODE = 290,         /* TOK_FOREACHNODE  */
    TOK_IFOFF = 291,               /* TOK_IFOFF  */
    TOK_IFON = 292,                /* TOK_IFON  */
    TOK_OFF_STRING = 293,          /* TOK_OFF_STRING  */
    TOK_ON_STRING = 294,           /* TOK_ON_STRING  */
    TOK_MAX_PLUG_COUNT = 295,      /* TOK_MAX_PLUG_COUNT  */
    TOK_TIMEOUT = 296,             /* TOK_TIMEOUT  */
    TOK_DEV_TIMEOUT = 297,         /* TOK_DEV_TIMEOUT  */
    TOK_PING_PERIOD = 298,         /* TOK_PING_PERIOD  */
    TOK_PLUG_NAME = 299,           /* TOK_PLUG_NAME  */
    TOK_SCRIPT = 300,              /* TOK_SCRIPT  */
    TOK_DEVICE = 301,              /* TOK_DEVICE  */
    TOK_NODE = 302,                /* TOK_NODE  */
    TOK_ALIAS = 303,               /* TOK_ALIAS  */
    TOK_TCP_WRAPPERS = 304,        /* TOK_TCP_WRAPPERS  */
    TOK_LISTEN = 305,              /* TOK_LISTEN  */
    TOK_PLUG_LOG_LEVEL = 306,      /* TOK_PLUG_LOG_LEVEL  */
    TOK_MATCHPOS = 307,            /* TOK_MATCHPOS  */
    TOK_STRING_VAL = 308,          /* TOK_STRING_VAL  */
    TOK_NUMERIC_VAL = 309,         /* TOK_NUMERIC_VAL  */
    TOK_YES = 310,                 /* TOK_YES  */
    TOK_NO = 311,                  /* TOK_NO  */
    TOK_BEGIN = 312,               /* TOK_BEGIN  */
    TOK_END = 313,                 /* TOK_END  */
    TOK_UNRECOGNIZED = 314,        /* TOK_UNRECOGNIZED  */
    TOK_EQUALS = 315,              /* TOK_EQUALS  */
    TOK_SUCCESS = 316              /* TOK_SUCCESS  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define TOK_LOGIN 258
#define TOK_LOGOUT 259
#define TOK_STATUS 260
#define TOK_STATUS_ALL 261
#define TOK_STATUS_TEMP 262
#define TOK_STATUS_TEMP_ALL 263
#define TOK_STATUS_BEACON 264
#define TOK_STATUS_BEACON_ALL 265
#define TOK_BEACON_ON 266
#define TOK_BEACON_ON_RANGED 267
#define TOK_BEACON_OFF 268
#define TOK_BEACON_OFF_RANGED 269
#define TOK_ON 270
#define TOK_ON_RANGED 271
#define TOK_ON_ALL 272
#define TOK_OFF 273
#define TOK_OFF_RANGED 274
#define TOK_OFF_ALL 275
#define TOK_CYCLE 276
#define TOK_CYCLE_RANGED 277
#define TOK_CYCLE_ALL 278
#define TOK_RESET 279
#define TOK_RESET_RANGED 280
#define TOK_RESET_ALL 281
#define TOK_PING 282
#define TOK_SPEC 283
#define TOK_EXPECT 284
#define TOK_SETPLUGSTATE 285
#define TOK_SETRESULT 286
#define TOK_SEND 287
#define TOK_DELAY 288
#define TOK_FOREACHPLUG 289
#define TOK_FOREACHNODE 290
#define TOK_IFOFF 291
#define TOK_IFON 292
#define TOK_OFF_STRING 293
#define TOK_ON_STRING 294
#define TOK_MAX_PLUG_COUNT 295
#define TOK_TIMEOUT 296
#define TOK_DEV_TIMEOUT 297
#define TOK_PING_PERIOD 298
#define TOK_PLUG_NAME 299
#define TOK_SCRIPT 300
#define TOK_DEVICE 301
#define TOK_NODE 302
#define TOK_ALIAS 303
#define TOK_TCP_WRAPPERS 304
#define TOK_LISTEN 305
#define TOK_PLUG_LOG_LEVEL 306
#define TOK_MATCHPOS 307
#define TOK_STRING_VAL 308
#define TOK_NUMERIC_VAL 309
#define TOK_YES 310
#define TOK_NO 311
#define TOK_BEGIN 312
#define TOK_END 313
#define TOK_UNRECOGNIZED 314
#define TOK_EQUALS 315
#define TOK_SUCCESS 316

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_PARSE_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_LOGIN = 3,                  /* TOK_LOGIN  */
  YYSYMBOL_TOK_LOGOUT = 4,                 /* TOK_LOGOUT  */
  YYSYMBOL_TOK_STATUS = 5,                 /* TOK_STATUS  */
  YYSYMBOL_TOK_STATUS_ALL = 6,             /* TOK_STATUS_ALL  */
  YYSYMBOL_TOK_STATUS_TEMP = 7,            /* TOK_STATUS_TEMP  */
  YYSYMBOL_TOK_STATUS_TEMP_ALL = 8,        /* TOK_STATUS_TEMP_ALL  */
  YYSYMBOL_TOK_STATUS_BEACON = 9,          /* TOK_STATUS_BEACON  */
  YYSYMBOL_TOK_STATUS_BEACON_ALL = 10,     /* TOK_STATUS_BEACON_ALL  */
  YYSYMBOL_TOK_BEACON_ON = 11,             /* TOK_BEACON_ON  */
  YYSYMBOL_TOK_BEACON_ON_RANGED = 12,      /* TOK_BEACON_ON_RANGED  */
  YYSYMBOL_TOK_BEACON_OFF = 13,            /* TOK_BEACON_OFF  */
  YYSYMBOL_TOK_BEACON_OFF_RANGED = 14,     /* TOK_BEACON_OFF_RANGED  */
  YYSYMBOL_TOK_ON = 15,                    /* TOK_ON  */
  YYSYMBOL_TOK_ON_RANGED = 16,             /* TOK_ON_RANGED  */
  YYSYMBOL_TOK_ON_ALL = 17,                /* TOK_ON_ALL  */
  YYSYMBOL_TOK_OFF = 18,                   /* TOK_OFF  */
  YYSYMBOL_TOK_OFF_RANGED = 19,            /* TOK_OFF_RANGED  */
  YYSYMBOL_TOK_OFF_ALL = 20,               /* TOK_OFF_ALL  */
  YYSYMBOL_TOK_CYCLE = 21,                 /* TOK_CYCLE  */
  YYSYMBOL_TOK_CYCLE_RANGED = 22,          /* TOK_CYCLE_RANGED  */
  YYSYMBOL_TOK_CYCLE_ALL = 23,             /* TOK_CYCLE_ALL  */
  YYSYMBOL_TOK_RESET = 24,                 /* TOK_RESET  */
  YYSYMBOL_TOK_RESET_RANGED = 25,          /* TOK_RESET_RANGED  */
  YYSYMBOL_TOK_RESET_ALL = 26,             /* TOK_RESET_ALL  */
  YYSYMBOL_TOK_PING = 27,                  /* TOK_PING  */
  YYSYMBOL_TOK_SPEC = 28,                  /* TOK_SPEC  */
  YYSYMBOL_TOK_EXPECT = 29,                /* TOK_EXPECT  */
  YYSYMBOL_TOK_SETPLUGSTATE = 30,          /* TOK_SETPLUGSTATE  */
  YYSYMBOL_TOK_SETRESULT = 31,             /* TOK_SETRESULT  */
  YYSYMBOL_TOK_SEND = 32,                  /* TOK_SEND  */
  YYSYMBOL_TOK_DELAY = 33,                 /* TOK_DELAY  */
  YYSYMBOL_TOK_FOREACHPLUG = 34,           /* TOK_FOREACHPLUG  */
  YYSYMBOL_TOK_FOREACHNODE = 35,           /* TOK_FOREACHNODE  */
  YYSYMBOL_TOK_IFOFF = 36,                 /* TOK_IFOFF  */
  YYSYMBOL_TOK_IFON = 37,                  /* TOK_IFON  */
  YYSYMBOL_TOK_OFF_STRING = 38,            /* TOK_OFF_STRING  */
  YYSYMBOL_TOK_ON_STRING = 39,             /* TOK_ON_STRING  */
  YYSYMBOL_TOK_MAX_PLUG_COUNT = 40,        /* TOK_MAX_PLUG_COUNT  */
  YYSYMBOL_TOK_TIMEOUT = 41,               /* TOK_TIMEOUT  */
  YYSYMBOL_TOK_DEV_TIMEOUT = 42,           /* TOK_DEV_TIMEOUT  */
  YYSYMBOL_TOK_PING_PERIOD = 43,           /* TOK_PING_PERIOD  */
  YYSYMBOL_TOK_PLUG_NAME = 44,             /* TOK_PLUG_NAME  */
  YYSYMBOL_TOK_SCRIPT = 45,                /* TOK_SCRIPT  */
  YYSYMBOL_TOK_DEVICE = 46,                /* TOK_DEVICE  */
  YYSYMBOL_TOK_NODE = 47,                  /* TOK_NODE  */
  YYSYMBOL_TOK_ALIAS = 48,                 /* TOK_ALIAS  */
  YYSYMBOL_TOK_TCP_WRAPPERS = 49,          /* TOK_TCP_WRAPPERS  */
  YYSYMBOL_TOK_LISTEN = 50,                /* TOK_LISTEN  */
  YYSYMBOL_TOK_PLUG_LOG_LEVEL = 51,        /* TOK_PLUG_LOG_LEVEL  */
  YYSYMBOL_TOK_MATCHPOS = 52,              /* TOK_MATCHPOS  */
  YYSYMBOL_TOK_STRING_VAL = 53,            /* TOK_STRING_VAL  */
  YYSYMBOL_TOK_NUMERIC_VAL = 54,           /* TOK_NUMERIC_VAL  */
  YYSYMBOL_TOK_YES = 55,                   /* TOK_YES  */
  YYSYMBOL_TOK_NO = 56,                    /* TOK_NO  */
  YYSYMBOL_TOK_BEGIN = 57,                 /* TOK_BEGIN  */
  YYSYMBOL_TOK_END = 58,                   /* TOK_END  */
  YYSYMBOL_TOK_UNRECOGNIZED = 59,          /* TOK_UNRECOGNIZED  */
  YYSYMBOL_TOK_EQUALS = 60,                /* TOK_EQUALS  */
  YYSYMBOL_TOK_SUCCESS = 61,               /* TOK_SUCCESS  */
  YYSYMBOL_YYACCEPT = 62,                  /* $accept  */
  YYSYMBOL_configuration_file = 63,        /* configuration_file  */
  YYSYMBOL_config_list = 64,               /* config_list  */
  YYSYMBOL_config_item = 65,               /* config_item  */
  YYSYMBOL_TCP_wrappers = 66,              /* TCP_wrappers  */
  YYSYMBOL_plug_log_level = 67,            /* plug_log_level  */
  YYSYMBOL_listen = 68,                    /* listen  */
  YYSYMBOL_device = 69,                    /* device  */
  YYSYMBOL_node = 70,                      /* node  */
  YYSYMBOL_alias = 71,                     /* alias  */
  YYSYMBOL_spec = 72,                      /* spec  */
  YYSYMBOL_spec_item_list = 73,            /* spec_item_list  */
  YYSYMBOL_spec_item = 74,                 /* spec_item  */
  YYSYMBOL_spec_timeout = 75,              /* spec_timeout  */
  YYSYMBOL_spec_ping_period = 76,          /* spec_ping_period  */
  YYSYMBOL_string_list = 77,               /* string_list  */
  YYSYMBOL_spec_plug_list = 78,            /* spec_plug_list  */
  YYSYMBOL_spec_script_list = 79,          /* spec_script_list  */
  YYSYMBOL_spec_script = 80,               /* spec_script  */
  YYSYMBOL_stmt_block = 81,                /* stmt_block  */
  YYSYMBOL_stmt_list = 82,                 /* stmt_list  */
  YYSYMBOL_stmt = 83,                      /* stmt  */
  YYSYMBOL_state_interp_list = 84,         /* state_interp_list  */
  YYSYMBOL_state_interp = 85,              /* state_interp  */
  YYSYMBOL_result_interp_list = 86,        /* result_interp_list  */
  YYSYMBOL_result_interp = 87,             /* result_interp  */
  YYSYMBOL_regmatch = 88                   /* regmatch  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  26
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   147

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  62
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  27
/* YYNRULES -- Number of rules.  */
#define YYNRULES  86
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  152

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   316


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   141,   141,   147,   148,   149,   151,   152,   153,   154,
     155,   156,   157,   159,   162,   164,   168,   172,   176,   179,
     183,   185,   189,   196,   202,   203,   205,   206,   207,   208,
     210,   214,   218,   221,   226,   232,   233,   235,   237,   239,
     241,   243,   245,   247,   249,   251,   253,   255,   257,   259,
     261,   263,   265,   267,   269,   271,   273,   275,   277,   279,
     281,   283,   287,   291,   294,   299,   302,   304,   306,   309,
     312,   315,   318,   321,   324,   327,   330,   333,   336,   341,
     344,   349,   351,   355,   358,   363,   367
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_LOGIN",
  "TOK_LOGOUT", "TOK_STATUS", "TOK_STATUS_ALL", "TOK_STATUS_TEMP",
  "TOK_STATUS_TEMP_ALL", "TOK_STATUS_BEACON", "TOK_STATUS_BEACON_ALL",
  "TOK_BEACON_ON", "TOK_BEACON_ON_RANGED", "TOK_BEACON_OFF",
  "TOK_BEACON_OFF_RANGED", "TOK_ON", "TOK_ON_RANGED", "TOK_ON_ALL",
  "TOK_OFF", "TOK_OFF_RANGED", "TOK_OFF_ALL", "TOK_CYCLE",
  "TOK_CYCLE_RANGED", "TOK_CYCLE_ALL", "TOK_RESET", "TOK_RESET_RANGED",
  "TOK_RESET_ALL", "TOK_PING", "TOK_SPEC", "TOK_EXPECT",
  "TOK_SETPLUGSTATE", "TOK_SETRESULT", "TOK_SEND", "TOK_DELAY",
  "TOK_FOREACHPLUG", "TOK_FOREACHNODE", "TOK_IFOFF", "TOK_IFON",
  "TOK_OFF_STRING", "TOK_ON_STRING", "TOK_MAX_PLUG_COUNT", "TOK_TIMEOUT",
  "TOK_DEV_TIMEOUT", "TOK_PING_PERIOD", "TOK_PLUG_NAME", "TOK_SCRIPT",
  "TOK_DEVICE", "TOK_NODE", "TOK_ALIAS", "TOK_TCP_WRAPPERS", "TOK_LISTEN",
  "TOK_PLUG_LOG_LEVEL", "TOK_MATCHPOS", "TOK_STRING_VAL",
  "TOK_NUMERIC_VAL", "TOK_YES", "TOK_NO", "TOK_BEGIN", "TOK_END",
  "TOK_UNRECOGNIZED", "TOK_EQUALS", "TOK_SUCCESS", "$accept",
  "configuration_file", "config_list", "config_item", "TCP_wrappers",
  "plug_log_level", "listen", "device", "node", "alias", "spec",
  "spec_item_list", "spec_item", "spec_timeout", "spec_ping_period",
  "string_list", "spec_plug_list", "spec_script_list", "spec_script",
  "stmt_block", "stmt_list", "stmt", "state_interp_list", "state_interp",
  "result_interp_list", "result_interp", "regmatch", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-86)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
      -3,   -27,     6,    40,    59,   -14,    60,    61,    62,    -3,
     -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,    58,    63,
      67,    68,   -86,   -86,   -86,   -86,   -86,   -86,    66,    69,
      70,   -86,    71,    72,    73,    64,    -5,   -86,   -86,   -86,
     -86,    74,   -86,    75,   -86,   -86,   -86,    76,    77,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      77,    77,    77,   -86,   -86,   -86,   -86,   -86,    -2,    65,
     -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,
     -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,
     -86,   -86,   -86,   -86,   -86,   -86,   -86,    78,    54,    80,
      82,    79,    77,    77,    77,    77,    -1,   -86,   -86,    83,
      80,     9,    80,   -86,   -86,   -86,   -86,   -86,   -86,   -86,
     -86,   -86,    34,    57,    81,    34,   -86,    34,    84,    34,
      85,    86,   -86,    34,    87,    84,   -86,   -86,   -86,    89,
     -86,   -86
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       5,     0,     0,     0,     0,    13,     0,     0,     0,     2,
       4,     7,     8,     6,     9,    10,    11,    12,     0,     0,
       0,     0,    14,    15,    17,    16,     1,     3,     0,     0,
      21,    22,     0,     0,     0,     0,     0,    25,    26,    27,
      28,    29,    36,    19,    20,    30,    31,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    23,    24,    35,    18,    33,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    32,    34,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    64,    65,     0,
       0,    72,     0,    66,    67,    76,    75,    77,    78,    62,
      63,    86,    68,     0,     0,    73,    80,    70,     0,    69,
       0,     0,    79,    71,     0,    74,    84,    81,    82,     0,
      83,    85
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -86,   -86,   -86,   109,   -86,   -86,   -86,   -86,   -86,   -86,
     -86,   -86,    88,   -86,   -86,   -86,   -86,   -86,    95,   -49,
     -86,    11,   -77,   -85,   -86,     1,   -17
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    36,    37,    38,    39,    78,    40,    41,    42,    80,
     116,   117,   135,   136,   145,   146,   121
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   133,     1,    18,   134,   107,   108,
     109,   110,   111,   112,   113,   114,   115,    32,    33,    34,
      35,    22,    23,     2,     3,     4,     5,     6,     7,   133,
     142,   105,   134,    73,   142,   139,   106,   129,   142,    19,
     143,   119,    26,   125,   126,   127,   128,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   122,    20,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   132,   137,   138,   119,   120,    32,    33,
      34,    35,    21,    24,    25,    28,    29,   140,    27,    35,
      30,    31,    43,    44,    74,    45,    46,   130,    76,    77,
      47,   118,   119,   124,    79,   123,    75,   131,   147,   148,
       0,   141,   151,     0,     0,   144,   150,   149
};

static const yytype_int16 yycheck[] =
{
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    15,    28,    53,    18,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    42,    43,    44,
      45,    55,    56,    46,    47,    48,    49,    50,    51,    15,
     135,    53,    18,    58,   139,   132,    58,    58,   143,    53,
     137,    52,     0,   112,   113,   114,   115,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,   109,    53,    29,    30,    31,    32,    33,    34,
      35,    36,    37,   120,   121,   122,    52,    53,    42,    43,
      44,    45,    53,    53,    53,    57,    53,    60,     9,    45,
      53,    53,    53,    53,    36,    54,    54,   116,    53,    53,
      57,    53,    52,    54,    57,    53,    41,    54,    53,    53,
      -1,    60,    53,    -1,    -1,    61,   145,    60
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    28,    46,    47,    48,    49,    50,    51,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    53,    53,
      53,    53,    55,    56,    53,    53,     0,    65,    57,    53,
      53,    53,    42,    43,    44,    45,    73,    74,    75,    76,
      78,    79,    80,    53,    53,    54,    54,    57,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    58,    74,    80,    53,    53,    77,    57,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    53,    58,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    82,    83,    53,    52,
      53,    88,    88,    53,    54,    81,    81,    81,    81,    58,
      83,    54,    88,    15,    18,    84,    85,    88,    88,    84,
      60,    60,    85,    84,    61,    86,    87,    53,    53,    60,
      87,    53
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    62,    63,    64,    64,    64,    65,    65,    65,    65,
      65,    65,    65,    66,    66,    66,    67,    68,    69,    69,
      70,    70,    71,    72,    73,    73,    74,    74,    74,    74,
      75,    76,    77,    77,    78,    79,    79,    80,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    81,    82,    82,    83,    83,    83,    83,    83,
      83,    83,    83,    83,    83,    83,    83,    83,    83,    84,
      84,    85,    85,    86,    86,    87,    88
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     5,     4,
       4,     3,     3,     5,     2,     1,     1,     1,     1,     1,
       2,     2,     2,     1,     4,     2,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     1,     2,     2,     2,     3,     4,
       3,     4,     2,     3,     4,     2,     2,     2,     2,     2,
       1,     3,     3,     2,     1,     3,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 13: /* TCP_wrappers: TOK_TCP_WRAPPERS  */
#line 159 "parse_tab.y"
                                           {
    _warnmsg("'tcpwrappers' without yes|no");
    conf_set_use_tcp_wrappers(true);
}
#line 1525 "parse_tab.c"
    break;

  case 14: /* TCP_wrappers: TOK_TCP_WRAPPERS TOK_YES  */
#line 162 "parse_tab.y"
                                           {
    conf_set_use_tcp_wrappers(true);
}
#line 1533 "parse_tab.c"
    break;

  case 15: /* TCP_wrappers: TOK_TCP_WRAPPERS TOK_NO  */
#line 164 "parse_tab.y"
                                           {
    conf_set_use_tcp_wrappers(false);
}
#line 1541 "parse_tab.c"
    break;

  case 16: /* plug_log_level: TOK_PLUG_LOG_LEVEL TOK_STRING_VAL  */
#line 168 "parse_tab.y"
                                                            {
    conf_set_plug_log_level(yyvsp[0]);
}
#line 1549 "parse_tab.c"
    break;

  case 17: /* listen: TOK_LISTEN TOK_STRING_VAL  */
#line 172 "parse_tab.y"
                                            {
    conf_add_listen(yyvsp[0]);
}
#line 1557 "parse_tab.c"
    break;

  case 18: /* device: TOK_DEVICE TOK_STRING_VAL TOK_STRING_VAL TOK_STRING_VAL TOK_STRING_VAL  */
#line 177 "parse_tab.y"
                                 {
    makeDevice(yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
}
#line 1565 "parse_tab.c"
    break;

  case 19: /* device: TOK_DEVICE TOK_STRING_VAL TOK_STRING_VAL TOK_STRING_VAL  */
#line 179 "parse_tab.y"
                                                                          {
    makeDevice(yyvsp[-2], yyvsp[-1], yyvsp[0], NULL);
}
#line 1573 "parse_tab.c"
    break;

  case 20: /* node: TOK_NODE TOK_STRING_VAL TOK_STRING_VAL TOK_STRING_VAL  */
#line 183 "parse_tab.y"
                                                                        {
    makeNode(yyvsp[-2], yyvsp[-1], yyvsp[0]);
}
#line 1581 "parse_tab.c"
    break;

  case 21: /* node: TOK_NODE TOK_STRING_VAL TOK_STRING_VAL  */
#line 185 "parse_tab.y"
                                                         {
    makeNode(yyvsp[-1], yyvsp[0], NULL);
}
#line 1589 "parse_tab.c"
    break;

  case 22: /* alias: TOK_ALIAS TOK_STRING_VAL TOK_STRING_VAL  */
#line 189 "parse_tab.y"
                                                          {
    makeAlias(yyvsp[-1], yyvsp[0]);
}
#line 1597 "parse_tab.c"
    break;

  case 23: /* spec: TOK_SPEC TOK_STRING_VAL TOK_BEGIN spec_item_list TOK_END  */
#line 198 "parse_tab.y"
                          {
    makeSpec(yyvsp[-3]);
}
#line 1605 "parse_tab.c"
    break;

  case 30: /* spec_timeout: TOK_DEV_TIMEOUT TOK_NUMERIC_VAL  */
#line 210 "parse_tab.y"
                                                  {
    _doubletotv(&current_spec.timeout, _strtodouble(yyvsp[0]));
}
#line 1613 "parse_tab.c"
    break;

  case 31: /* spec_ping_period: TOK_PING_PERIOD TOK_NUMERIC_VAL  */
#line 214 "parse_tab.y"
                                                  {
    _doubletotv(&current_spec.ping_period, _strtodouble(yyvsp[0]));
}
#line 1621 "parse_tab.c"
    break;

  case 32: /* string_list: string_list TOK_STRING_VAL  */
#line 218 "parse_tab.y"
                                             {
    list_append((List)yyvsp[-1], xstrdup(yyvsp[0]));
    yyval = yyvsp[-1];
}
#line 1630 "parse_tab.c"
    break;

  case 33: /* string_list: TOK_STRING_VAL  */
#line 221 "parse_tab.y"
                                 {
    yyval = (char *)list_create((ListDelF)xfree);
    list_append((List)yyval, xstrdup(yyvsp[0]));
}
#line 1639 "parse_tab.c"
    break;

  case 34: /* spec_plug_list: TOK_PLUG_NAME TOK_BEGIN string_list TOK_END  */
#line 226 "parse_tab.y"
                                                              {
    if (current_spec.plugs != NULL)
        _errormsg("duplicate plug list");
    current_spec.plugs = (List)yyvsp[-1];
}
#line 1649 "parse_tab.c"
    break;

  case 37: /* spec_script: TOK_SCRIPT TOK_LOGIN stmt_block  */
#line 235 "parse_tab.y"
                                                  {
    makeScript(PM_LOG_IN, (List)yyvsp[0]);
}
#line 1657 "parse_tab.c"
    break;

  case 38: /* spec_script: TOK_SCRIPT TOK_LOGOUT stmt_block  */
#line 237 "parse_tab.y"
                                                   {
    makeScript(PM_LOG_OUT, (List)yyvsp[0]);
}
#line 1665 "parse_tab.c"
    break;

  case 39: /* spec_script: TOK_SCRIPT TOK_STATUS stmt_block  */
#line 239 "parse_tab.y"
                                                   {
    makeScript(PM_STATUS_PLUGS, (List)yyvsp[0]);
}
#line 1673 "parse_tab.c"
    break;

  case 40: /* spec_script: TOK_SCRIPT TOK_STATUS_ALL stmt_block  */
#line 241 "parse_tab.y"
                                                       {
    makeScript(PM_STATUS_PLUGS_ALL, (List)yyvsp[0]);
}
#line 1681 "parse_tab.c"
    break;

  case 41: /* spec_script: TOK_SCRIPT TOK_STATUS_TEMP stmt_block  */
#line 243 "parse_tab.y"
                                                        {
    makeScript(PM_STATUS_TEMP, (List)yyvsp[0]);
}
#line 1689 "parse_tab.c"
    break;

  case 42: /* spec_script: TOK_SCRIPT TOK_STATUS_TEMP_ALL stmt_block  */
#line 245 "parse_tab.y"
                                                            {
    makeScript(PM_STATUS_TEMP_ALL, (List)yyvsp[0]);
}
#line 1697 "parse_tab.c"
    break;

  case 43: /* spec_script: TOK_SCRIPT TOK_STATUS_BEACON stmt_block  */
#line 247 "parse_tab.y"
                                                          {
    makeScript(PM_STATUS_BEACON, (List)yyvsp[0]);
}
#line 1705 "parse_tab.c"
    break;

  case 44: /* spec_script: TOK_SCRIPT TOK_STATUS_BEACON_ALL stmt_block  */
#line 249 "parse_tab.y"
                                                              {
    makeScript(PM_STATUS_BEACON_ALL, (List)yyvsp[0]);
}
#line 1713 "parse_tab.c"
    break;

  case 45: /* spec_script: TOK_SCRIPT TOK_BEACON_ON stmt_block  */
#line 251 "parse_tab.y"
                                                      {
    makeScript(PM_BEACON_ON, (List)yyvsp[0]);
}
#line 1721 "parse_tab.c"
    break;

  case 46: /* spec_script: TOK_SCRIPT TOK_BEACON_ON_RANGED stmt_block  */
#line 253 "parse_tab.y"
                                                             {
    makeScript(PM_BEACON_ON_RANGED, (List)yyvsp[0]);
}
#line 1729 "parse_tab.c"
    break;

  case 47: /* spec_script: TOK_SCRIPT TOK_BEACON_OFF stmt_block  */
#line 255 "parse_tab.y"
                                                       {
    makeScript(PM_BEACON_OFF, (List)yyvsp[0]);
}
#line 1737 "parse_tab.c"
    break;

  case 48: /* spec_script: TOK_SCRIPT TOK_BEACON_OFF_RANGED stmt_block  */
#line 257 "parse_tab.y"
                                                              {
    makeScript(PM_BEACON_OFF_RANGED, (List)yyvsp[0]);
}
#line 1745 "parse_tab.c"
    break;

  case 49: /* spec_script: TOK_SCRIPT TOK_ON stmt_block  */
#line 259 "parse_tab.y"
                                               {
    makeScript(PM_POWER_ON, (List)yyvsp[0]);
}
#line 1753 "parse_tab.c"
    break;

  case 50: /* spec_script: TOK_SCRIPT TOK_ON_RANGED stmt_block  */
#line 261 "parse_tab.y"
                                                      {
    makeScript(PM_POWER_ON_RANGED, (List)yyvsp[0]);
}
#line 1761 "parse_tab.c"
    break;

  case 51: /* spec_script: TOK_SCRIPT TOK_ON_ALL stmt_block  */
#line 263 "parse_tab.y"
                                                   {
    makeScript(PM_POWER_ON_ALL, (List)yyvsp[0]);
}
#line 1769 "parse_tab.c"
    break;

  case 52: /* spec_script: TOK_SCRIPT TOK_OFF stmt_block  */
#line 265 "parse_tab.y"
                                                {
    makeScript(PM_POWER_OFF, (List)yyvsp[0]);
}
#line 1777 "parse_tab.c"
    break;

  case 53: /* spec_script: TOK_SCRIPT TOK_OFF_RANGED stmt_block  */
#line 267 "parse_tab.y"
                                                       {
    makeScript(PM_POWER_OFF_RANGED, (List)yyvsp[0]);
}
#line 1785 "parse_tab.c"
    break;

  case 54: /* spec_script: TOK_SCRIPT TOK_OFF_ALL stmt_block  */
#line 269 "parse_tab.y"
                                                    {
    makeScript(PM_POWER_OFF_ALL, (List)yyvsp[0]);
}
#line 1793 "parse_tab.c"
    break;

  case 55: /* spec_script: TOK_SCRIPT TOK_CYCLE stmt_block  */
#line 271 "parse_tab.y"
                                                  {
    makeScript(PM_POWER_CYCLE, (List)yyvsp[0]);
}
#line 1801 "parse_tab.c"
    break;

  case 56: /* spec_script: TOK_SCRIPT TOK_CYCLE_RANGED stmt_block  */
#line 273 "parse_tab.y"
                                                         {
    makeScript(PM_POWER_CYCLE_RANGED, (List)yyvsp[0]);
}
#line 1809 "parse_tab.c"
    break;

  case 57: /* spec_script: TOK_SCRIPT TOK_CYCLE_ALL stmt_block  */
#line 275 "parse_tab.y"
                                                      {
    makeScript(PM_POWER_CYCLE_ALL, (List)yyvsp[0]);
}
#line 1817 "parse_tab.c"
    break;

  case 58: /* spec_script: TOK_SCRIPT TOK_RESET stmt_block  */
#line 277 "parse_tab.y"
                                                  {
    makeScript(PM_RESET, (List)yyvsp[0]);
}
#line 1825 "parse_tab.c"
    break;

  case 59: /* spec_script: TOK_SCRIPT TOK_RESET_RANGED stmt_block  */
#line 279 "parse_tab.y"
                                                         {
    makeScript(PM_RESET_RANGED, (List)yyvsp[0]);
}
#line 1833 "parse_tab.c"
    break;

  case 60: /* spec_script: TOK_SCRIPT TOK_RESET_ALL stmt_block  */
#line 281 "parse_tab.y"
                                                      {
    makeScript(PM_RESET_ALL, (List)yyvsp[0]);
}
#line 1841 "parse_tab.c"
    break;

  case 61: /* spec_script: TOK_SCRIPT TOK_PING stmt_block  */
#line 283 "parse_tab.y"
                                                 {
    makeScript(PM_PING, (List)yyvsp[0]);
}
#line 1849 "parse_tab.c"
    break;

  case 62: /* stmt_block: TOK_BEGIN stmt_list TOK_END  */
#line 287 "parse_tab.y"
                                              {
    yyval = yyvsp[-1];
}
#line 1857 "parse_tab.c"
    break;

  case 63: /* stmt_list: stmt_list stmt  */
#line 291 "parse_tab.y"
                                 {
    list_append((List)yyvsp[-1], yyvsp[0]);
    yyval = yyvsp[-1];
}
#line 1866 "parse_tab.c"
    break;

  case 64: /* stmt_list: stmt  */
#line 294 "parse_tab.y"
                       {
    yyval = (char *)list_create((ListDelF)destroyPreStmt);
    list_append((List)yyval, yyvsp[0]);
}
#line 1875 "parse_tab.c"
    break;

  case 65: /* stmt: TOK_EXPECT TOK_STRING_VAL  */
#line 299 "parse_tab.y"
                                            {
    yyval = (char *)makePreStmt(STMT_EXPECT, yyvsp[0], NULL, NULL, NULL, NULL, NULL,
                             NULL);
}
#line 1884 "parse_tab.c"
    break;

  case 66: /* stmt: TOK_SEND TOK_STRING_VAL  */
#line 302 "parse_tab.y"
                                          {
    yyval = (char *)makePreStmt(STMT_SEND, yyvsp[0], NULL, NULL, NULL, NULL, NULL, NULL);
}
#line 1892 "parse_tab.c"
    break;

  case 67: /* stmt: TOK_DELAY TOK_NUMERIC_VAL  */
#line 304 "parse_tab.y"
                                            {
    yyval = (char *)makePreStmt(STMT_DELAY, NULL, yyvsp[0], NULL, NULL, NULL, NULL, NULL);
}
#line 1900 "parse_tab.c"
    break;

  case 68: /* stmt: TOK_SETPLUGSTATE TOK_STRING_VAL regmatch  */
#line 306 "parse_tab.y"
                                                           {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, yyvsp[-1], NULL, NULL, yyvsp[0], NULL, NULL,
                             NULL);
}
#line 1909 "parse_tab.c"
    break;

  case 69: /* stmt: TOK_SETPLUGSTATE TOK_STRING_VAL regmatch state_interp_list  */
#line 309 "parse_tab.y"
                                                                             {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, yyvsp[-2], NULL, NULL, yyvsp[-1], NULL,
                             (List)yyvsp[0], NULL);
}
#line 1918 "parse_tab.c"
    break;

  case 70: /* stmt: TOK_SETPLUGSTATE regmatch regmatch  */
#line 312 "parse_tab.y"
                                                     {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, NULL, NULL, yyvsp[-1], yyvsp[0], NULL, NULL,
                             NULL);
}
#line 1927 "parse_tab.c"
    break;

  case 71: /* stmt: TOK_SETPLUGSTATE regmatch regmatch state_interp_list  */
#line 315 "parse_tab.y"
                                                                       {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, NULL, NULL, yyvsp[-2], yyvsp[-1], NULL,
                             (List)yyvsp[0], NULL);
}
#line 1936 "parse_tab.c"
    break;

  case 72: /* stmt: TOK_SETPLUGSTATE regmatch  */
#line 318 "parse_tab.y"
                                            {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, NULL, NULL, NULL, yyvsp[0], NULL, NULL,
                             NULL);
}
#line 1945 "parse_tab.c"
    break;

  case 73: /* stmt: TOK_SETPLUGSTATE regmatch state_interp_list  */
#line 321 "parse_tab.y"
                                                              {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, NULL, NULL, NULL,yyvsp[-1],NULL,
                             (List)yyvsp[0], NULL);
}
#line 1954 "parse_tab.c"
    break;

  case 74: /* stmt: TOK_SETRESULT regmatch regmatch result_interp_list  */
#line 324 "parse_tab.y"
                                                                     {
    yyval = (char *)makePreStmt(STMT_SETRESULT, NULL, NULL, yyvsp[-2], yyvsp[-1], NULL,
                             NULL, (List)yyvsp[0]);
}
#line 1963 "parse_tab.c"
    break;

  case 75: /* stmt: TOK_FOREACHNODE stmt_block  */
#line 327 "parse_tab.y"
                                             {
    yyval = (char *)makePreStmt(STMT_FOREACHNODE, NULL, NULL, NULL, NULL,
                             (List)yyvsp[0], NULL, NULL);
}
#line 1972 "parse_tab.c"
    break;

  case 76: /* stmt: TOK_FOREACHPLUG stmt_block  */
#line 330 "parse_tab.y"
                                             {
    yyval = (char *)makePreStmt(STMT_FOREACHPLUG, NULL, NULL, NULL, NULL,
                             (List)yyvsp[0], NULL, NULL);
}
#line 1981 "parse_tab.c"
    break;

  case 77: /* stmt: TOK_IFOFF stmt_block  */
#line 333 "parse_tab.y"
                                       {
    yyval = (char *)makePreStmt(STMT_IFOFF, NULL, NULL, NULL, NULL,
                             (List)yyvsp[0], NULL, NULL);
}
#line 1990 "parse_tab.c"
    break;

  case 78: /* stmt: TOK_IFON stmt_block  */
#line 336 "parse_tab.y"
                                      {
    yyval = (char *)makePreStmt(STMT_IFON, NULL, NULL, NULL, NULL,
                             (List)yyvsp[0], NULL, NULL);
}
#line 1999 "parse_tab.c"
    break;

  case 79: /* state_interp_list: state_interp_list state_interp  */
#line 341 "parse_tab.y"
                                                         {
    list_append((List)yyvsp[-1], yyvsp[0]);
    yyval = yyvsp[-1];
}
#line 2008 "parse_tab.c"
    break;

  case 80: /* state_interp_list: state_interp  */
#line 344 "parse_tab.y"
                               {
    yyval = (char *)list_create((ListDelF)destroyStateInterp);
    list_append((List)yyval, yyvsp[0]);
}
#line 2017 "parse_tab.c"
    break;

  case 81: /* state_interp: TOK_ON TOK_EQUALS TOK_STRING_VAL  */
#line 349 "parse_tab.y"
                                                           {
    yyval = (char *)makeStateInterp(ST_ON, yyvsp[0]);
}
#line 2025 "parse_tab.c"
    break;

  case 82: /* state_interp: TOK_OFF TOK_EQUALS TOK_STRING_VAL  */
#line 351 "parse_tab.y"
                                                      {
    yyval = (char *)makeStateInterp(ST_OFF, yyvsp[0]);
}
#line 2033 "parse_tab.c"
    break;

  case 83: /* result_interp_list: result_interp_list result_interp  */
#line 355 "parse_tab.y"
                                                            {
    list_append((List)yyvsp[-1], yyvsp[0]);
    yyval = yyvsp[-1];
}
#line 2042 "parse_tab.c"
    break;

  case 84: /* result_interp_list: result_interp  */
#line 358 "parse_tab.y"
                                {
    yyval = (char *)list_create((ListDelF)destroyResultInterp);
    list_append((List)yyval, yyvsp[0]);
}
#line 2051 "parse_tab.c"
    break;

  case 85: /* result_interp: TOK_SUCCESS TOK_EQUALS TOK_STRING_VAL  */
#line 363 "parse_tab.y"
                                                                 {
    yyval = (char *)makeResultInterp(RT_SUCCESS, yyvsp[0]);
}
#line 2059 "parse_tab.c"
    break;

  case 86: /* regmatch: TOK_MATCHPOS TOK_NUMERIC_VAL  */
#line 367 "parse_tab.y"
                                                 {
    yyval = yyvsp[0];
}
#line 2067 "parse_tab.c"
    break;


#line 2071 "parse_tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 371 "parse_tab.y"


void scanner_init(char *filename);
void scanner_fini(void);
int scanner_line(void);
char *scanner_file(void);

/*
 * Entry point into the yacc/lex parser.
 */
int parse_config_file (char *filename)
{
    extern FILE *yyin; /* part of lexer */

    scanner_init(filename);

    yyin = fopen(filename, "r");
    if (!yyin)
        err_exit(true, "%s", filename);

    device_specs = list_create((ListDelF) destroySpec);

    yyparse();
    fclose(yyin);

    scanner_fini();

    list_destroy(device_specs);

    return 0;
}

/* makePreStmt(type, str, tv, mp1(plug), mp2(stat/node), prestmts,
 *             state_interps, result_interps */
static PreStmt *makePreStmt(StmtType type, char *str, char *tvstr,
                      char *mp1str, char *mp2str, List prestmts,
                      List state_interps, List result_interps)
{
    PreStmt *new;

    new = (PreStmt *) xmalloc(sizeof(PreStmt));

    new->type = type;
    new->mp1 = mp1str ? _strtolong(mp1str) : -1;
    new->mp2 = mp2str ? _strtolong(mp2str) : -1;
    if (str)
        new->str = xstrdup(str);
    if (tvstr)
        _doubletotv(&new->tv, _strtodouble(tvstr));
    new->prestmts = prestmts;
    new->state_interps = state_interps;
    new->result_interps = result_interps;

    return new;
}

static void destroyPreStmt(PreStmt *p)
{
    if (p->str)
        xfree(p->str);
    p->str = NULL;
    if (p->prestmts)
        list_destroy(p->prestmts);
    p->prestmts = NULL;
    if (p->state_interps)
        list_destroy(p->state_interps);
    p->state_interps = NULL;
    if (p->result_interps)
        list_destroy(p->result_interps);
    p->result_interps = NULL;
    xfree(p);
}

static Spec *_copy_current_spec(void)
{
    Spec *new = (Spec *) xmalloc(sizeof(Spec));

    *new = current_spec;
    memset (&current_spec, 0, sizeof (current_spec));
    return new;
}

static Spec *makeSpec(char *name)
{
    Spec *spec;

    current_spec.name = xstrdup(name);

    /* FIXME: check for manditory scripts here?  what are they? */

    spec = _copy_current_spec();
    assert(device_specs != NULL);
    list_append(device_specs, spec);

    return spec;
}

static void destroySpec(Spec * spec)
{
    int i;

    if (spec->name)
        xfree(spec->name);
    if (spec->plugs)
        list_destroy(spec->plugs);
    for (i = 0; i < NUM_SCRIPTS; i++)
        if (spec->prescripts[i])
            list_destroy(spec->prescripts[i]);
    xfree(spec);
}

static int matchSpec(Spec * spec, void *key)
{
    return (strcmp(spec->name, (char *) key) == 0);
}

static Spec *findSpec(char *name)
{
    return list_find_first(device_specs, (ListFindF) matchSpec, name);
}

static void makeScript(int com, List stmts)
{
    if (current_spec.prescripts[com] != NULL)
        _errormsg("duplicate script");
    current_spec.prescripts[com] = stmts;
}

static StateInterp *makeStateInterp(InterpState state, char *str)
{
    StateInterp *new = (StateInterp *)xmalloc(sizeof(StateInterp));

    new->str = xstrdup(str);
    new->re = xregex_create();
    new->state = state;

    return new;
}

static void destroyStateInterp(StateInterp *i)
{
    xfree(i->str);
    xregex_destroy(i->re);
    xfree(i);
}

static List copyStateInterpList(List il)
{
    ListIterator itr;
    StateInterp *ip, *icpy;
    List new = list_create((ListDelF) destroyStateInterp);

    if (il != NULL) {

        itr = list_iterator_create(il);
        while((ip = list_next(itr))) {
            icpy = makeStateInterp(ip->state, ip->str);
            xregex_compile(icpy->re, icpy->str, false);
            list_append(new, icpy);
        }
        list_iterator_destroy(itr);
    }

    return new;
}

static ResultInterp *makeResultInterp(InterpResult result, char *str)
{
    ResultInterp *new = (ResultInterp *)xmalloc(sizeof(ResultInterp));

    new->str = xstrdup(str);
    new->re = xregex_create();
    new->result = result;

    return new;
}

static void destroyResultInterp(ResultInterp *i)
{
    xfree(i->str);
    xregex_destroy(i->re);
    xfree(i);
}

static List copyResultInterpList(List il)
{
    ListIterator itr;
    ResultInterp *ip, *icpy;
    List new = list_create((ListDelF) destroyResultInterp);

    if (il != NULL) {

        itr = list_iterator_create(il);
        while((ip = list_next(itr))) {
            icpy = makeResultInterp(ip->result, ip->str);
            xregex_compile(icpy->re, icpy->str, false);
            list_append(new, icpy);
        }
        list_iterator_destroy(itr);
    }

    return new;
}

/**
 ** Powerman.conf stuff.
 **/

static void destroyStmt(Stmt *stmt)
{
    assert(stmt != NULL);

    switch (stmt->type) {
    case STMT_SEND:
        xfree(stmt->u.send.fmt);
        break;
    case STMT_EXPECT:
        xregex_destroy(stmt->u.expect.exp);
        break;
    case STMT_DELAY:
        break;
    case STMT_SETPLUGSTATE:
        list_destroy(stmt->u.setplugstate.interps);
        xfree (stmt->u.setplugstate.plug_name);
        break;
    case STMT_SETRESULT:
        list_destroy(stmt->u.setresult.interps);
        break;
    case STMT_FOREACHNODE:
    case STMT_FOREACHPLUG:
        list_destroy(stmt->u.foreach.stmts);
        break;
    case STMT_IFON:
    case STMT_IFOFF:
        list_destroy(stmt->u.ifonoff.stmts);
        break;
    default:
        break;
    }
    xfree(stmt);
}

static Stmt *makeStmt(PreStmt *p)
{
    Stmt *stmt;
    PreStmt *subp;
    ListIterator itr;

    stmt = (Stmt *) xmalloc(sizeof(Stmt));
    stmt->type = p->type;
    switch (p->type) {
    case STMT_SEND:
        stmt->u.send.fmt = xstrdup(p->str);
        break;
    case STMT_EXPECT:
        stmt->u.expect.exp = xregex_create();
        xregex_compile(stmt->u.expect.exp, p->str, true);
        break;
    case STMT_SETPLUGSTATE:
        stmt->u.setplugstate.stat_mp = p->mp2;
        if (p->str)
            stmt->u.setplugstate.plug_name = xstrdup(p->str);
        else
            stmt->u.setplugstate.plug_mp = p->mp1;
        stmt->u.setplugstate.interps = copyStateInterpList(p->state_interps);
        break;
    case STMT_SETRESULT:
        stmt->u.setresult.stat_mp = p->mp2;
        stmt->u.setresult.plug_mp = p->mp1;
        stmt->u.setresult.interps = copyResultInterpList(p->result_interps);
        break;
    case STMT_DELAY:
        stmt->u.delay.tv = p->tv;
        break;
    case STMT_FOREACHNODE:
    case STMT_FOREACHPLUG:
        stmt->u.foreach.stmts = list_create((ListDelF) destroyStmt);
        itr = list_iterator_create(p->prestmts);
        while((subp = list_next(itr))) {
            list_append(stmt->u.foreach.stmts, makeStmt(subp));
        }
        list_iterator_destroy(itr);
        break;
    case STMT_IFON:
    case STMT_IFOFF:
        stmt->u.ifonoff.stmts = list_create((ListDelF) destroyStmt);
        itr = list_iterator_create(p->prestmts);
        while((subp = list_next(itr))) {
            list_append(stmt->u.ifonoff.stmts, makeStmt(subp));
        }
        list_iterator_destroy(itr);
        break;
    default:
        break;
    }
    return stmt;
}

static void _parse_hoststr(Device *dev, char *hoststr, char *flagstr)
{
    /* pipe device, e.g. "conman -j baytech0 |&" */
    if (strstr(hoststr, "|&") != NULL) {
        dev->data           = pipe_create(hoststr, flagstr);
        dev->destroy        = pipe_destroy;
        dev->connect        = pipe_connect;
        dev->disconnect     = pipe_disconnect;
        dev->finish_connect = NULL;
        dev->preprocess     = NULL;

    /* serial device, e.g. "/dev/ttyS0" */
    } else if (hoststr[0] == '/') {
        struct stat sb;

        if (stat(hoststr, &sb) == -1 || (!(sb.st_mode & S_IFCHR)))
            _errormsg("serial device not found or not a char special file");

        dev->data           = serial_create(hoststr, flagstr);
        dev->destroy        = serial_destroy;
        dev->connect        = serial_connect;
        dev->disconnect     = serial_disconnect;
        dev->finish_connect = NULL;
        dev->preprocess     = NULL;

    /* tcp device, e.g. "cyclades0:2001" */
    } else {
        char *port = strchr(hoststr, ':');
        int n;

        if (port) {                 /* host='host:port', flags=NULL */
            *port++ = '\0';
        } else
            _errormsg("hostname is missing :port");

        n = _strtolong(port);       /* verify port number */
        if (n < 1 || n > 65535)
            _errormsg("port number out of range");
        dev->data           = tcp_create(hoststr, port, flagstr);
        dev->destroy        = tcp_destroy;
        dev->connect        = tcp_connect;
        dev->disconnect     = tcp_disconnect;
        dev->finish_connect = tcp_finish_connect;
        dev->preprocess     = tcp_preprocess;
    }
}

static void makeDevice(char *devstr, char *specstr, char *hoststr,
                        char *flagstr)
{
    ListIterator itr;
    Device *dev;
    Spec *spec;
    int i;

    /* find that spec */
    spec = findSpec(specstr);
    if ( spec == NULL )
        _errormsg("device specification not found");

    /* make the Device */
    dev = dev_create(devstr);
    dev->specname = xstrdup(specstr);
    dev->timeout = spec->timeout;
    dev->ping_period = spec->ping_period;

    _parse_hoststr(dev, hoststr, flagstr);

    /* create plugs (spec->plugs may be NULL) */
    dev->plugs = pluglist_create(spec->plugs);

    /* transfer remaining info from the spec to the device */
    for (i = 0; i < NUM_SCRIPTS; i++) {
        PreStmt *p;

        if (spec->prescripts[i] == NULL) {
            dev->scripts[i] = NULL;
            continue; /* unimplemented script */
        }

        dev->scripts[i] = list_create((ListDelF) destroyStmt);

        /* copy the list of statements in each script */
        itr = list_iterator_create(spec->prescripts[i]);
        while((p = list_next(itr))) {
            list_append(dev->scripts[i], makeStmt(p));
        }
        list_iterator_destroy(itr);
    }

    dev_add(dev);
}

static void makeAlias(char *namestr, char *hostsstr)
{
    if (!conf_add_alias(namestr, hostsstr))
        _errormsg("bad alias");
}

static void makeNode(char *nodestr, char *devstr, char *plugstr)
{
    Device *dev = dev_findbyname(devstr);

    if (dev == NULL)
        _errormsg("unknown device");

    /* plugstr can be NULL - see comment in pluglist.h */
    switch (pluglist_map(dev->plugs, nodestr, plugstr)) {
        case EPL_DUPNODE:
            _errormsg("duplicate node");
        case EPL_UNKPLUG:
            _errormsg("unknown plug name");
        case EPL_DUPPLUG:
            _errormsg("plug already assigned");
        case EPL_NOPLUGS:
            _errormsg("more nodes than plugs");
        case EPL_NONODES:
            _errormsg("more plugs than nodes");
        default:
            break;
    }

    if (!conf_addnodes(nodestr))
        _errormsg("duplicate node name");
}

/**
 ** Utility functions
 **/

static double _strtodouble(char *str)
{
    char *endptr;
    double val = strtod(str, &endptr);

    if (val == 0.0 && endptr == str)
        _errormsg("error parsing double value");
    if ((val == HUGE_VAL || val == -HUGE_VAL) && errno == ERANGE)
        _errormsg("double value would cause overflow");
    return val;
}

static long _strtolong(char *str)
{
    char *endptr;
    long val = strtol(str, &endptr, 0);

    if (val == 0 && endptr == str)
        _errormsg("error parsing long integer value");
    if ((val == LONG_MIN || val == LONG_MAX) && errno == ERANGE)
        _errormsg("long integer value would cause under/overflow");
    return val;
}

static void _doubletotv(struct timeval *tv, double val)
{
    tv->tv_sec = (val * 10.0)/10; /* crude round-down without -lm */
    tv->tv_usec = ((val - tv->tv_sec) * 1000000.0);
}

static void _errormsg(char *msg)
{
    err_exit(false, "%s: %s::%d", msg, scanner_file(), scanner_line());
}

static void _warnmsg(char *msg)
{
    err(false, "warning: %s: %s::%d", msg, scanner_file(), scanner_line());
}

void yyerror()
{
    _errormsg("parse error");
}

/*
 * vi:tabstop=4 shiftwidth=4 expandtab
 */
